#include "compresspopup.h"
#include "file.h"
#include "quicktime.h"

CompressPopup::CompressPopup(int x, int y, int recording, char *text)
 : BC_PopupMenu(x, y, 80, compression_to_text(text))
{
	strcpy(format, text);
	this->recording = recording;
}

int CompressPopup::add_items()
{
	if(!recording) add_item(format_items[0] = new CompressPopupItem("DV"));
	add_item(format_items[1] = new CompressPopupItem("JPEG"));
	add_item(format_items[2] = new CompressPopupItem("MJPA"));
	add_item(format_items[3] = new CompressPopupItem("PNG"));
	add_item(format_items[4] = new CompressPopupItem("PNG-Alpha"));
	add_item(format_items[5] = new CompressPopupItem("RGB"));
	add_item(format_items[6] = new CompressPopupItem("RGB-Alpha"));
	add_item(format_items[7] = new CompressPopupItem("YUV420"));
	add_item(format_items[8] = new CompressPopupItem("YUV422"));
	return 0;
}

CompressPopup::~CompressPopup()
{
	for(int i = 0; i < COMPRESS_ITEMS; i++) delete format_items[i];
}

char* CompressPopup::get_compression()
{
	File test_file;
	return test_file.strtocompression(get_text());
}

char* CompressPopup::compression_to_text(char *compression)
{
	File test_file;
	return test_file.compressiontostr(compression);
}

CompressPopupItem::CompressPopupItem(char *text)
 : BC_PopupItem(text)
{
}

CompressPopupItem::~CompressPopupItem()
{
}
	
int CompressPopupItem::handle_event()
{
	get_menu()->update(get_text());
	get_menu()->handle_event();
}
